searchNodes=[{"doc":"A JSON library powered by Rust's Serde through a NIF","ref":"Jsonrs.html","title":"Jsonrs","type":"module"},{"doc":"Parses a JSON value from input string. Similar to decode/2 except it will raise in case of errors. Examples iex&gt; Jsonrs . decode! ( &quot;{ \\&quot; x \\&quot; :[1,2]}&quot; ) %{ &quot;x&quot; =&gt; [ 1 , 2 ] } iex&gt; Jsonrs . decode! ( &quot;invalid&quot; ) ** (ErlangError) Erlang error: &quot;expected value at line 1 column 1&quot;","ref":"Jsonrs.html#decode!/2","title":"Jsonrs.decode!/2","type":"function"},{"doc":"Parses a JSON value from input string. Examples iex&gt; Jsonrs . decode ( &quot;{ \\&quot; x \\&quot; :[1,2]}&quot; ) { :ok , %{ &quot;x&quot; =&gt; [ 1 , 2 ] } } iex&gt; Jsonrs . decode ( &quot;invalid&quot; ) { :error , &quot;expected value at line 1 column 1&quot; }","ref":"Jsonrs.html#decode/2","title":"Jsonrs.decode/2","type":"function"},{"doc":"Generates JSON corresponding to input . Similar to encode/1 except it will raise in case of errors. Examples iex&gt; Jsonrs . encode! ( %{ &quot;x&quot; =&gt; [ 1 , 2 ] } ) &quot;{ \\&quot; x \\&quot; :[1,2]}&quot; iex&gt; Jsonrs . encode! ( &quot; \\x FF&quot; ) ** (ErlangError) Erlang error: :encode_error","ref":"Jsonrs.html#encode!/2","title":"Jsonrs.encode!/2","type":"function"},{"doc":"Generates JSON corresponding to input . Examples iex&gt; Jsonrs . encode ( %{ &quot;x&quot; =&gt; [ 1 , 2 ] } ) { :ok , &quot;{ \\&quot; x \\&quot; :[1,2]}&quot; } iex&gt; Jsonrs . encode ( &quot; \\x FF&quot; ) { :error , :encode_error }","ref":"Jsonrs.html#encode/2","title":"Jsonrs.encode/2","type":"function"},{"doc":"Identical to encode!/1 . Exists to implement Phoenix interface and encodes to a single normal string.","ref":"Jsonrs.html#encode_to_iodata!/2","title":"Jsonrs.encode_to_iodata!/2","type":"function"},{"doc":"Identical to encode/1 . Exists to implement Phoenix interface and encodes to a single normal string.","ref":"Jsonrs.html#encode_to_iodata/2","title":"Jsonrs.encode_to_iodata/2","type":"function"},{"doc":"Protocol controlling how a value is encoded to JSON. By default, structs are encoded as maps without the :__struct__ key. If this is sufficient for you use, you don't need to implement this protocol. When implementing an encoding function, the goal is to turn your value into something already capable of being encoded. Example An implementation of this protocol for Decimal might look something like defimpl Jsonrs.Encoder , for : Decimal do def encode ( value ) do Decimal . to_string ( value ) end end Which will cause the Decimal to be encoded as its string representation","ref":"Jsonrs.Encoder.html","title":"Jsonrs.Encoder","type":"protocol"},{"doc":"Converts value to a JSON-encodable type.","ref":"Jsonrs.Encoder.html#encode/1","title":"Jsonrs.Encoder.encode/1","type":"function"},{"doc":"","ref":"Jsonrs.Encoder.html#t:t/0","title":"Jsonrs.Encoder.t/0","type":"type"},{"doc":"A safe NIF-based JSON library for Elixir powered by Rust's Serde. API Documentation .","ref":"readme.html","title":"Jsonrs","type":"extras"},{"doc":"Add Jsonrs as a dependency in your mix.exs file. def deps do [ { :jsonrs , &quot;~&gt; 0.2&quot; } ] end To avoid requiring an entire Rust toolchain for projects that use Jsonrs, pre-built binaries are provided via Rustler Precompiled , which will download a platform-specific binary from the appropriate Github release during compilation. If you would like to avoid using the pre-built binaries, set the environment variable FORCE_JSONRS_BUILD=true when building.","ref":"readme.html#installation","title":"Jsonrs - Installation","type":"extras"},{"doc":"Jsonrs is much faster than other JSON libraries for Elixir, including other NIFs like jiffy. It uses much less memory than other JSON libraries when operating in a mode with comparable features. It has an API typical of Elixir JSON libraries. decode/1 encode/2 and encode_to_iodata/2 are available along with their raising ! counterparts, and structs can implement the Jsonrs.Encoder protocol to specify custom encoding. Multiple operating modes allow you to turn off features you don't need for extra performance. In the default 2-pass mode, Jsonrs works like Jason and Poison and honors custom encoding of structs. In the opt-in 1-pass ( lean ) mode, Jsonrs will ignore custom encoding impls and operate more like jiffy.","ref":"readme.html#summary","title":"Jsonrs - Summary","type":"extras"},{"doc":"Jsonrs is a 2-pass encoder by default. The first pass involves mapping the input object according to any custom encodings implemented for types in the input. This is done in Elixir. The second pass performs the actual encoding of the input to a JSON string. This is done in the Rust NIF. If custom encoding defintions are not required, the first pass can be disabled entirely by passing lean: true in the encode opts. When operating in this mode, structs will always be encoded as if they were maps regardless of custom encoder implementations.","ref":"readme.html#encoder-design","title":"Jsonrs - Encoder Design","type":"extras"},{"doc":"Jsonrs has different performance characteristics in different modes. In the default 2-pass mode, Jsonrs is comparable feature-wise to Jason or Poison and should always be much faster (~5-10x) and consume less memory (~3-30x) than either of them when working with any non-trivial JSON. In lean mode, Jsonrs is comparable feature-wise to jiffy and should always be faster (~3x) and use less memory (~100x+) than it. For example, here is a benchmark of Jsonrs's speed and memory consumption compared to other popular JSON libraries when encoding the 8MB issue-90.json from the Poison benchmark data. It is easy to see that Jsonrs dramatically outperforms Poison and Jason, while Jsonrs-lean similarly outperforms jiffy.","ref":"readme.html#performance","title":"Jsonrs - Performance","type":"extras"},{"doc":"Jsonrs.decode/1 takes a JSON string and turns it into an Elixir term. Jsonrs.encode/2 takes an Elixir term and a keyword list of options and turns the input term into a JSON string with behavior defined by the options. Valid options are: lean : disables the first encoder pass (default false ) pretty : turns on pretty printing when true or a non-negative-integer specifying indentation size (default false )","ref":"readme.html#quick-start","title":"Jsonrs - Quick Start","type":"extras"},{"doc":"Basic usage iex&gt; Jsonrs . encode! ( %{ &quot;x&quot; =&gt; [ 1 , 2 ] , &quot;y&quot; =&gt; 0.5 } ) &quot;{ \\&quot; x \\&quot; :[1,2], \\&quot; y \\&quot; :0.5}&quot; iex&gt; Jsonrs . decode! ( &quot;{ \\&quot; x \\&quot; :[1,2], \\&quot; y \\&quot; :0.5}&quot; ) %{ &quot;x&quot; =&gt; [ 1 , 2 ] , &quot;y&quot; =&gt; 0.5 } iex&gt; Jsonrs . encode! ( %{ &quot;x&quot; =&gt; false , &quot;y&quot; =&gt; [ ] } , pretty : true ) |&gt; IO . puts ( ) { &quot;x&quot; : false , &quot;y&quot; : [ ] } Defining a custom encoder Implement Jsonrs.Encoder for your struct, with an encode/1 function that returns any other type encodable by Jsonrs (it does not need to return a string). For example: defimpl Jsonrs.Encoder , for : [ MapSet , Range , Stream ] do def encode ( struct ) , do : Enum . to_list ( struct ) end","ref":"readme.html#examples","title":"Jsonrs - Examples","type":"extras"},{"doc":"Jsonrs is built on the backs of giants. It is connecting the Rust libraries Serde_rustler and Serde_json , exposing them to Elixir through Rustler , and wrapping the NIF in an interface inspired by Jason . Without these projects, Jsonrs probably wouldn't exist.","ref":"readme.html#credits","title":"Jsonrs - Credits","type":"extras"}]